
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.Sprite;
import javax.microedition.midlet.*;
import java.io.IOException;

public class GraphicsExample extends MIDlet
{
   private MyCanvas myCanvas;

   class MyCanvas extends Canvas
   {
      private Image alienHeadImage = null;

      public MyCanvas()
      {
         try
         {
            alienHeadImage = Image.createImage("/alienhead.png");
         }
         catch (IOException ioe)
         {
            System.out.println("unable to load image");
         }
      }

      protected void paint(Graphics g)
      {
         g.setColor(0, 0, 0);
         g.fillRect(0, 0, getWidth(), getHeight());
         g.setColor(0xffffff);
         int y=0;

         // TRANS NONE
         g.drawRegion(alienHeadImage, 0, 0,
                      alienHeadImage.getWidth(), alienHeadImage.getHeight(),
                      Sprite.TRANS_NONE, 0, y, Graphics.TOP | Graphics.LEFT);
         g.drawString("TRANS_NONE", alienHeadImage.getWidth() + 10, y,
                      Graphics.TOP | Graphics.LEFT);
         y += alienHeadImage.getHeight();

         // TRANS ROT 90
         g.drawRegion(alienHeadImage, 0, 0,
                      alienHeadImage.getWidth(), alienHeadImage.getHeight(),
                      Sprite.TRANS_ROT90, 0, y, Graphics.TOP | Graphics.LEFT);
         g.drawString("TRANS_ROT90", alienHeadImage.getWidth() + 10, y,
                      Graphics.TOP | Graphics.LEFT);
         y += alienHeadImage.getHeight();

         // TRANS ROT 180
         g.drawRegion(alienHeadImage, 0, 0,
                      alienHeadImage.getWidth(), alienHeadImage.getHeight(),
                      Sprite.TRANS_ROT180, 0, y, Graphics.TOP | Graphics.LEFT);
         g.drawString("TRANS_ROT180", alienHeadImage.getWidth() + 10, y,
                      Graphics.TOP | Graphics.LEFT);
         y += alienHeadImage.getHeight();

         // TRANS ROT 270
         g.drawRegion(alienHeadImage, 0, 0,
                      alienHeadImage.getWidth(), alienHeadImage.getHeight(),
                      Sprite.TRANS_ROT270, 0, y, Graphics.TOP | Graphics.LEFT);
         g.drawString("TRANS_ROT270", alienHeadImage.getWidth() + 10, y,
                      Graphics.TOP | Graphics.LEFT);
         y += alienHeadImage.getHeight();

         // TRANS MIRROR
         g.drawRegion(alienHeadImage, 0, 0,
                      alienHeadImage.getWidth(), alienHeadImage.getHeight(),
                      Sprite.TRANS_MIRROR, 0, y, Graphics.TOP | Graphics.LEFT);
         g.drawString("TRANS_MIRROR", alienHeadImage.getWidth() + 10, y,
                      Graphics.TOP | Graphics.LEFT);
         y += alienHeadImage.getHeight();

         // TRANS MIRROR_ROT90
         g.drawRegion(alienHeadImage, 0, 0,
                      alienHeadImage.getWidth(), alienHeadImage.getHeight(),
                      Sprite.TRANS_MIRROR_ROT90, 0, y, Graphics.TOP | Graphics.LEFT);
         g.drawString("TRANS_MIRROR_ROT90", alienHeadImage.getWidth() + 10, y,
                      Graphics.TOP | Graphics.LEFT);
         y += alienHeadImage.getHeight();

         // TRANS MIRROR_ROT180
         g.drawRegion(alienHeadImage, 0, 0,
                      alienHeadImage.getWidth(), alienHeadImage.getHeight(),
                      Sprite.TRANS_MIRROR_ROT180, 0, y, Graphics.TOP | Graphics.LEFT);
         g.drawString("TRANS_MIRROR_ROT180", alienHeadImage.getWidth() + 10, y,
                      Graphics.TOP | Graphics.LEFT);
         y += alienHeadImage.getHeight();

         // TRANS MIRROR_ROT270
         g.drawRegion(alienHeadImage, 0, 0,
                      alienHeadImage.getWidth(), alienHeadImage.getHeight(),
                      Sprite.TRANS_MIRROR_ROT270, 0, y, Graphics.TOP | Graphics.LEFT);
         g.drawString("TRANS_MIRROR_ROT270", alienHeadImage.getWidth() + 10, y,
                      Graphics.TOP | Graphics.LEFT);
      }

   }

   public GraphicsExample()
   {
      myCanvas = new MyCanvas();
   }

   protected void startApp() throws MIDletStateChangeException
   {
      Display.getDisplay(this).setCurrent(myCanvas);
   }

   protected void pauseApp()
   {
   }

   protected void destroyApp(boolean unconditional) throws MIDletStateChangeException
   {
   }
}
